/***************************************************************************
 *   Copyright (C) 2004 by Georges A.Khalil                                *
 *   georges.abou-khalil@polymtl.ca                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CONFIGDLG_H_
#define _CONFIGDLG_H_

#include <kconfigdialog.h>

class TrayEmbedList;
class configDlgIcons;
class configDlgButton;
class Config;

class configDlg : public KConfigDialog
{
	Q_OBJECT
public:
	configDlg(QWidget *parent, const char *name, TrayEmbedList *pList);
	~configDlg();

	void show();

protected:
	bool hasChanged();

protected slots:
	void updateSettings();
	void slotIconListDirty();
	void slotButtonIconDirty();

private:
	configDlgIcons *lIconsDlg;
	configDlgButton *lButtonDlg;
	TrayEmbedList *mList;
	bool mIconListDirty;
	bool mButtonIconDirty;
};

#endif
