/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <kwin.h>
#include <qtable.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include "trayembedlist.h"

void configDlgIcons::init()
{
	mIconTable->setLeftMargin( 0 );
	mIconTable->verticalHeader()->hide();
	mIconTable->setFocusStyle(QTable::FollowStyle);
}

class ComboItem : public QTableItem
{
public:

	ComboItem ( QTable * table, EditType et ) : 
		QTableItem (table, et ) { }
	
	~ComboItem() {  }

	QWidget *createEditor() const
	{
		// create an editor - a combobox in our case
		((ComboItem*)this)->cb = new QComboBox( table()->viewport() );
		QObject::connect( cb, SIGNAL( activated( int ) ), table(), SLOT( doValueChanged() ) );
		cb->insertItem( "Always visible" );
		cb->insertItem( "Always hidden" );
		// and initialize it
		cb->setCurrentItem( text() == "Always hidden" ? 1 : 0 );
		return cb;
	}
	void setContentFromEditor( QWidget *w )
	{
		// the user changed the value of the combobox, so synchronize the
		// value of the item (its text), with the value of the combobox
		if ( w->inherits( "QComboBox" ) )
			setText( ( (QComboBox*)w )->currentText() );
		else
			QTableItem::setContentFromEditor( w );
	}
protected:
	QComboBox *cb;
};

class SpinItem : public QTableItem
{
public:

	SpinItem ( QTable * table, EditType et ) : 
		QTableItem (table, et ) { }
	
	~SpinItem() {  }

	QWidget *createEditor() const
	{
		// create an editor - a spinbox in our case
		((SpinItem*)this)->sb = new QSpinBox( table()->viewport() );
		sb->setMinValue(-1000);
		sb->setMaxValue(1000);
		QObject::connect( sb, SIGNAL( valueChanged( int ) ), table(), SLOT( doValueChanged() ) );
		// and initialize it
		sb->setValue( text().toInt() );
		return sb;
	}
	void setContentFromEditor( QWidget *w )
	{
		// the user changed the value of the combobox, so synchronize the
		// value of the item (its text), with the value of the combobox
		if ( w->inherits( "QSpinBox" ) )
			setText( ( (QSpinBox*)w )->text() );
		else
			QTableItem::setContentFromEditor( w );
	}
protected:
	QSpinBox *sb;
};

void configDlgIcons::refreshIcons(TrayEmbedList *pList)
{
	mIconTable->setNumRows(0);

	for (TrayEmbed* lEmb=pList->first();lEmb!=0L;lEmb=pList->next()) {
		WId lWId = lEmb->embeddedWinId();
		mIconTable->insertRows(0);
		mIconTable->setItem(0, 0, new QTableItem(mIconTable, QTableItem::Never));
		mIconTable->setPixmap(0, 0, QPixmap::grabWindow(lWId));
		mIconTable->setItem(0, 1, new QTableItem(mIconTable, QTableItem::Never));
		mIconTable->setText(0, 1, KWin::WindowInfo(lWId, 0, 0).visibleName());
		mIconTable->setItem(0, 2, new ComboItem(mIconTable, QTableItem::WhenCurrent));
		if (lEmb->isCollapsed()) {
			mIconTable->setText(0, 2, "Always hidden");
		} else {
			mIconTable->setText(0, 2, "Always visible");
		}
		mIconTable->item(0, 2)->createEditor();
		mIconTable->setItem(0, 3, new SpinItem(mIconTable, QTableItem::WhenCurrent));
		mIconTable->setText(0, 3, QString::number(lEmb->getPriority()));
		mIconTable->item(0, 3)->createEditor();
		mIconTable->adjustRow(0);
	}
	mIconTable->adjustColumn(0);
	mIconTable->adjustColumn(1);
	mIconTable->adjustColumn(2);
	mIconTable->adjustColumn(3);
}
