/* This file is part of the KDE project
   Copyright (C) 2003-2004 Nadeem Hasan <nhasan@kde.org>
   Copyright (C) 2004 Georges A.K. <georgesak@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef HIDEBUTTON_H
#define HIDEBUTTON_H

#include <qbutton.h>
#include <qpixmap.h>

class HideButton : public QButton
{
Q_OBJECT

public:
	HideButton( QWidget *parent, const char *name="" );
	void setPixmap( const QPixmap &pix );

	void loadIcon(QString pIconName);

	void showLeftArrow();
	void showRightArrow();
	void showUpArrow();
	void showDownArrow();


protected:
	void drawButton( QPainter *p );
	void drawButtonLabel( QPainter *p );
	QSize margin() const { return QSize( 5, 5 ); }
	QSize pixmapSize() const { return size() - margin(); }
	void generateIcons();
	
	void enterEvent( QEvent *e );
	void leaveEvent( QEvent *e );
	void resizeEvent( QResizeEvent *e );
	void mousePressEvent ( QMouseEvent * e );

protected slots:
	void slotSettingsChanged( int category );
	void slotIconChanged( int group );

signals:
	void rightClick();

protected:
	bool mHighlighted;
	QPixmap mNormalIcons[4];
	QPixmap mActiveIcons[4];
	int mDirection;
};

#endif // HIDEBUTTON_H

