/*****************************************************************

Copyright (c) 1996-2001 the kicker authors. See file AUTHORS.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************/

#ifndef _SYSTEMTRAYAPPLET2_H_
#define _SYSTEMTRAYAPPLET2_H_

#include <kpanelapplet.h>

#include <X11/Xlib.h>
#include <qbutton.h>

#include "config.h"
#include "trayembedlist.h"

class KWinModule;
class HideButton;


class SystemTrayApplet2 : public KPanelApplet
{
	Q_OBJECT

public:

	SystemTrayApplet2(const QString& configFile, Type t = Normal, int actions = 0,
					QWidget *parent = 0, const char *name = 0);
	~SystemTrayApplet2();

	int widthForHeight(int h) const;
	int heightForWidth(int w) const;
	int maxIconWidth() const;
	int maxIconHeight() const;

protected:
	void resizeEvent( QResizeEvent* );
	void about();

	bool x11Event( XEvent *e );
	void enterEvent( QEvent * );
	void leaveEvent( QEvent * );

protected slots:
	void preferences();
	void systemTrayWindowAdded( WId );
	void updateTrayWindows();
	void layoutTray();
	void paletteChange(const QPalette & /* oldPalette */);
	void slotLoadSettings();
	void hideButtonClicked();
	void slotSmoothScrollTimer();

private:
	void embedWindow( WId w, bool kde_tray );

private:
	TrayEmbedList m_Wins;
	KWinModule *kwin_module;
	Atom net_system_tray_selection;
	Atom net_system_tray_opcode;
	bool showFrame;

	bool mCollapsed;
	HideButton *mHideButton;
	QTimer *mAutoHideTimer;
	QTimer *mSmoothScrollTimer;
};

#endif //_SYSTEMTRAYAPPLET2_H_
