/*****************************************************************

Copyright (c) 2004      Georges A.Khalil <georgesak@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************/

#ifndef _TRAYEMBED_H_
#define _TRAYEMBED_H_

#include <qxembed.h>

class TrayEmbed : public QXEmbed
{
	Q_OBJECT
public:
	TrayEmbed(bool kdeTray, QWidget* parent=NULL);
	bool kdeTray() const;
	bool isCollapsed() const;
	void setCollapsed(bool c);
	int getPriority() const;
	void setPriority(int p);

	bool operator==(const TrayEmbed &p) const;
	bool operator<(const TrayEmbed &p) const;

private:
	bool kde_tray;
	bool mCollapsed;
	int mPriority;
};


#endif //_TRAYEMBED_H_
